/*
 * RemoteDisplay.c
 *
 * Created: 05.10.2012 16:04:52
 *  Author: Roland
 */ 

#include <avr/io.h>
#include "Timer.h"
#include "Lcd.h"
#include "RFM70.h"
#include "stdio.h"

uint8_t buf[40];
uint8_t len;
uint8_t PacketCnt=0;
char str[25];
int bat;
unsigned long pos;
float posf;
uint8_t anr,n,m;
int16_t p1,p2;
uint8_t s;
char sc;
uint32_t vbat;

#define TYPE_24BIT2 0
#define TYPE_24BIT1 1
#define TYPE_7NIBBLE 2

struct Cfg {
	uint8_t Channel;
	uint8_t Type;
	uint8_t PktCnt;
	} Cfg[3+3]= {
		{ 10,TYPE_24BIT1,0 },
		{ 20,TYPE_24BIT1,0 },
		{ 30,TYPE_24BIT2,0 },
		{ 40,TYPE_24BIT2,0 },
		{ 50,TYPE_24BIT2,0 },
		{ 60,TYPE_24BIT2,0 }
			
		}	;



uint32_t b2pos10um(uint32_t pos, uint8_t *sn, uint8_t t)
{
	uint8_t s;
	
	switch (t)
	{
		
		case TYPE_24BIT2:
			if(pos>=0x080000)
			{
				 s=1;
				 pos=(uint32_t)0x01000000-(uint32_t)pos;
			}
			else
				{
					 s=0;
				}

			pos=pos*127/1024; // Position in 1/100 mm Schritten berechnen
			if(s) pos-=0x20;
			break;
			
		case TYPE_24BIT1:
			if(pos&0x00100000)
				{
					s=1;
				}
			else
			{
				s=0;
			}
			pos&=0x000fffff;
			if(pos&0x00080000)
			{
				pos=pos&0xf;
				s=1;
			}
			else if(s) pos+=0x10;
			break;
			
			default:
				pos=0;
				s=0;
				
	}
	if(sn) *sn=s;
	return pos;
}


int main(void)
{
	// /CE: PB2 Mask 0x04
	// /CSN: PB4 Mask 0x10
	// MOSI: PB5 Mask 0x20
	// MISO: PB6 Mask 0x40
	// SCK: PB7 Mask 0x80
	
	// Port LCD BL: PB3 (1=On) Mask 0x08
	
	// Initialisierung Port B (RFM70 Funkmodul)
	
	PORTB|=0x1c; // /CSN und /CE auf inaktiv (Hi), LCDBL auf an (Hi) 
	DDRB|=0xbc; // LCDBL,/CE,/CSN,MOSI,SCK auf Output
	DDRD&=~0x78; // PD6-PD3 Input
	PORTD|=0x78; //Enable Pullups
	
	// LCD Kontrastspannung PD7 Mask 0x80
	
	
	
	PORTD&=~0x80;
	DDRD|=0x80;

	Timer_Init();
	init_port();
	RFM70_Initialize();
	Timer_Delayms(500);
	Lcd_Init();
	Timer_Delayms(100);
	Lcd_SetBackLight(0x30);
	Lcd_Clr();
	Lcd_PutS("RemoteDisplay");
	Lcd_SetPos(0,1);
	Lcd_PutS("Start...");
	Timer_Delayms(200);

	Lcd_SetPos(0,1);
	Lcd_PutS("X:              ");
	
	Lcd_SetPos(0,2);
	Lcd_PutS("Y:");
	
	Lcd_SetPos(0,3);
	Lcd_PutS("Z:");

    while(1)
	{
		m=(PIND&(1<<PD6))>>PD6;
        //TODO:: Please write your application code 
		for (anr=0;anr<3;anr++)
		{
			SetChannelNum(Cfg[anr+m*3].Channel);
			Timer_Delayms(10);
			Rfm70_FlushRxFifo();

			for(n=0;n<3;n++)
			{
				Timer_Delayms(30);
				len=Receive_Packet(buf,32);
				if(len>0) break;
			}
			
			if(len>=6)
			{
				vbat=(unsigned long)buf[4]+256ul*(unsigned long)buf[5];
			}
			else 
			{
				vbat=0;
			}
			// vbat=x/1024*1.1*1330/330; [V]
			vbat=(vbat*1330ul*11)/(1024ul*330ul);
			
			if(len>=3)
			{
				Cfg[anr+m*3].PktCnt++;
				pos=(unsigned long)buf[0]+256ul*(unsigned long)buf[1]+65535ul*(unsigned long)buf[2]+65536ul*256ul*(unsigned long)buf[3];

				pos=b2pos10um(pos,&s,Cfg[anr+m].Type);
				
				p1=pos/100;
				p2=pos-p1*100;
				//if(s) p1=-p1;
				sc= s? '-' : '+';				
				Lcd_SetPos(0,1+anr);
				Lcd_PutS("                ");
				sprintf(str,"%c:%c%03d.%02d %02d/%3d",'X'+anr,sc,(int)p1,(int)p2,(int)vbat,(int)Cfg[anr+m*3].PktCnt);
				Lcd_SetPos(0,1+anr);
				Lcd_PutS(str);
			}
		}
		
    }
}